package com.huigou.topsun.sap.sapApplication.application.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.huigou.topsun.sap.common.HttpClient;
import com.huigou.topsun.sap.common.domain.SapResult;
import com.huigou.topsun.sap.sapApplication.domain.query.SapDialogOrderQuery;
import com.huigou.topsun.sap.sapApplication.domain.query.SapDialogQuery;
import com.huigou.topsun.sap.sapApplication.application.SapMaterialApplication;
import com.huigou.topsun.sap.sapApplication.domain.vo.SapMaterialVo;

import com.huigou.topsun.util.SAPUtils;
import com.huigou.util.JSONUtil;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.io.IOException;
import java.util.*;

/**
 * @Auther: xin.lu
 * @Date: 2024/03/03/11:13
 * @Description:
 */
@Service("sapMaterialApplication")
public class SapMaterialApplicationImpl implements SapMaterialApplication {
    @Resource
    private HttpClient httpClient;
    @Override
    public List<Map<String,String>> getSapMaterial(SapDialogQuery queryRequest) throws IOException {
        List<Map<String,String>>  sapMaterialVoList = new ArrayList<>();
        /*if (StringUtil.isBlank(queryRequest.getWerks()) || StringUtil.isBlank(queryRequest.getMatkl())){
            return sapMaterialVoList;
        }*/
        if  (queryRequest.getMaktx()==null){
            queryRequest.setMaktx("");
        }
        if  (queryRequest.getMatkl()==null){
            queryRequest.setMatkl("");
        }
        String json = httpClient.execute(queryRequest, "search/sch_matnr");
        Map<String, Object> map = JSONUtil.toMap(json);
        SapResult sapResult = JSONObject.parseObject(JSONUtil.toString(map.get("MSG")), SapResult.class);
        if ("S".equals(sapResult.getTYPE())){
            ObjectMapper objectMapper = SAPUtils.objectMapper();
            sapMaterialVoList = objectMapper.readValue(JSONUtil.toString(map.get("RDATA")), new TypeReference<List<Map<String, String>>>() {});
            //sapMaterialVoList = (List<Map<String,String>>) JSONArray.parse(JSONUtil.toString(map.get("RDATA")));
        }else {
            throw new RuntimeException("查询物料失败："+sapResult.getMESSAGE());
        }
        return sapMaterialVoList;
    }


    @Override
    public List<Map<String, String>>  getSapCustomerOrder(SapDialogOrderQuery queryRequest) throws IOException {
        List<Map<String,String>>  sapOrderVoList= new ArrayList<>();

            //String jsonParams="KUNNR:[{\"SIGN\": \"\",\"OPTION\": \"\",\"LOW\":"+queryRequest.getKunnr()+",\"HIGH\": \"\"}]";
            StringBuffer sb = new StringBuffer("{");
        if  (StringUtils.isNotBlank(queryRequest.getWerks())) { //客户订单号
            sb.append("'WERKS':[{'SIGN':'I','OPTION':'EQ','LOW':'").append(queryRequest.getWerks()).append("','HIGH':''}]");
        }
        if  (StringUtils.isNotBlank(queryRequest.getKunnr())) {
            sb.append(",'KUNNR':[{'SIGN':'I','OPTION':'EQ','LOW':'").append(queryRequest.getKunnr()).append("','HIGH':''}]");
        }
        if  (StringUtils.isNotBlank(queryRequest.getVbeln())) { //客户销售订单号
            sb.append(",'VBELN':[{'SIGN':'I','OPTION':'EQ','LOW':'").append(queryRequest.getVbeln()).append("','HIGH':''}]");
        }
           sb.append("}");
           Object obj = JSONArray.parse(sb.toString());
        try {
         String json = httpClient.execute(obj, "SALES_ORDERS/SALES");
         List<Map<String, Object>> mapList = JSONUtil.toListMap(json);
         if (StringUtils.isNotBlank(queryRequest.getVbeln())) { //按生产订单号
             for (Map map : mapList) {
                 Map newMap = new HashMap();
                 List<Map<String, Object>> mapList2=(List<Map<String, Object>>)map.get("ITEM");
                 newMap.put("MATNR", mapList2.get(0).get("MATNR"));
                 newMap.put("MAKTX", mapList2.get(0).get("MAKTX"));
                 newMap.put("AUFNR", mapList2.get(0).get("AUFNR"));


                 newMap.put("PSMNG", mapList2.get(0).get("PSMNG")); //生产数量
                 newMap.put("EDATU", mapList2.get(0).get("EDATU"));               //出货日期
                        // KPEIN //定价单位
                 newMap.put("KWERT", mapList2.get(0).get("KWERT"));  //       //折前总金额
                 newMap.put("KOEIN", mapList2.get(0).get("KOEIN")); //         币别
                 sapOrderVoList.add(newMap);
             }
         } else if  (StringUtils.isNotBlank(queryRequest.getKunnr())) {  //查询订单号
             for (Map map : mapList) {
                 Map newMap = new HashMap();
                 newMap.put("BSTNK", map.get("BSTNK"));
                 newMap.put("VBELN", map.get("VBELN"));
                 newMap.put("KUNNR", map.get("KUNNR"));
                 newMap.put("NAME1", map.get("NAME1"));
                 sapOrderVoList.add(newMap);
             }
         } else {  //仅查询客户
             for (Map map : mapList) {
                 Map newMap = new HashMap();
                 newMap.put("KUNNR", map.get("KUNNR"));
                 newMap.put("NAME1", map.get("NAME1"));
                 sapOrderVoList.add(newMap);
             }
         }
        // ObjectMapper objectMapper = SAPUtils.objectMapper();
        // sapOrderVoList = objectMapper.readValue(JSONUtil.toString(json), new TypeReference<List<Map<String, String>>>() {
        // });

        // if (StringUtils.isNotBlank(queryRequest.getVbeln())) { //客户订单号
          //   sapOrderVoList = objectMapper.readValue(JSONUtil.toString(mapList.get(0).get("ITEM")), new TypeReference<List<Map<String, String>>>() {
           //  });
        // }

     } catch (Exception ex){
         throw new RuntimeException("查询客户订单失败："+ex.getMessage());
         //ex.printStackTrace();
     }
        return sapOrderVoList;
    }
}
